"""
Do Not Edit this file. You may and are encouraged to look at it for reference.
"""

import unittest
import isbn_index

class test_recordBookAction( unittest.TestCase ):

    def input_replacement( self, prompt ):
        self.assertFalse( self.too_many_inputs )
        self.input_given_prompt = prompt
        r = self.input_response_list[ self.input_response_index ]
        self.input_response_index += 1
        if self.input_response_index >= len( self.input_response_list ):
            self.input_response_index = 0
            self.too_many_inputs = True
        return r
    
    def setUp(self):
        
        self.too_many_inputs = False
        self.input_given_prompt = None
        self.input_response_index = 0
        self.input_response_list = [ "" ]
        isbn_index.input = self.input_replacement

        return

    def tearDown(self):
        return
    
    def test001_recordBookActionExists(self):
        self.assertTrue('recordBookAction' in dir( isbn_index ),
                        'Function "recordBookAction" is not defined, check your spelling')
        return
    
    def test002_recordBookActionAddsABook(self):
        index = { }
        isbn = "0000-12345678"
        title = "War of the Worlds"
        expected = { isbn: title }

        self.input_response_list = [ isbn + "\n", title + "\n" ]
        isbn_index.recordBookAction( index )
        
        self.assertDictEqual( index, expected )
        return

if __name__ == '__main__':
    unittest.main()
